import java.util.ArrayList;

class Panneau {

	public double largeur;
	public double hauteur;
	public String repere;
	public int nombre;
	public boolean fil;

	public double getSurface(){
		return largeur*hauteur;
	}

	public Panneau(Panneau pan){
		largeur = pan.largeur;
		hauteur = pan.hauteur;
		repere = pan.repere;
		nombre = pan.nombre;
		fil = pan.fil;
	}

	public Panneau(double largeur2, double hauteur2) {
		largeur = largeur2;
		hauteur = hauteur2;
	}

	public Panneau(double largeur2, double hauteur2, String repere2) {
		largeur = largeur2;
		hauteur = hauteur2;
		repere = repere2;
	}

	public Panneau(double largeur2, double hauteur2, String repere2, int nombre2) {
		largeur = largeur2;
		hauteur = hauteur2;
		repere = repere2;
		nombre = nombre2;
	}
	
	public Panneau(double largeur2, double hauteur2, String repere2, int nombre2, boolean fil2) {
		largeur = largeur2;
		hauteur = hauteur2;
		repere = repere2;
		nombre = nombre2;
		fil = fil2;
	}

	/**Défini le numéro de feuille à -1 pour indiquer que le panneau n'entre pas*/
	public PanneauPositionne horsFeuille(){
		PanneauPositionne p = new PanneauPositionne(this);
		p.numFeuille = -1;
		return p;
	}

	public Panneau clone(){
		Panneau res = new Panneau(this);
		return res;
	}

	/**Tri la liste de panneaux fournie par ordre de surface croissante
	 * @param tabl : La liste à trier
	 * @return la nouvelle liste triée*/ 
	public static ArrayList<Panneau> TriSurface(ArrayList<Panneau> tabl){

		Panneau p;
		int j;

		for(int i = 1 ; i<tabl.size() ; i++){
			p = tabl.get(i);
			j = i;
			while (j > 0){
				if (p.getSurface() > tabl.get(j-1).getSurface()){
					tabl.set(j, tabl.get(j-1));
					j -= 1;
				}else{
					break;
				}
			}
			tabl.set(j, p);
		}

		return tabl;
	}
}